#!/bin/bash

# creates a config file which contains the following information:
# For each screen name, it store the corresponding id of the wacom device.

export SCRENCONFIG=$(declare -A SCREENCONFIG)
#set -x

xrandrscreens=$(xrandr | grep connected | grep -v disconnected)
IFS=$'\n'; for i in ${xrandrscreens}
do
	NAME=$(echo $i | sed 's/ .*//')
	FORMAT=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+')
	WIDTH=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 1p)
	HEIGHT=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 2p)
	XPOS=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 3p)
	YPOS=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 4p)
	let "MYXPOS = ($WIDTH+1)/2 + $XPOS"
	let "MYYPOS = ($HEIGHT+1)/2 + $YPOS"
	SCREEN=$(
		(sleep .4;wmctrl -r "MapStylus Screen Finder" -R "MapStylus Screen Finder" -e 0,$MYXPOS,$MYYPOS,-1,-1) |
			kdialog --yes-label Laptop --no-label Wacom --cancel-label other --title "MapStylus Screen Finder" --yesnocancel "What screen is this dialog on?";
		echo $?
	)

	if [ $SCREEN -eq 0 ]
	then
		for j in $(xsetwacom --list | grep -v One | sed 's/^.*id: //' | sed 's/	.*$//')
		do
			# $NAME contains the name of the laptop screen (ex. eDP-1)
			# $j is a wacom input device that is NOT part of the wacom one tablet. (ex. 13)
			SCREENCONFIG[$j]=$NAME
		done
	elif [ $SCREEN -eq 1 ]
	then
		for j in $(xsetwacom --list | grep One | sed 's/^.*id: //' | sed 's/	.*$//')
		do
			# $NAME contains the name of the laptop screen (ex. HDMI-2)
			# $j is a wacom input device that is part of the wacom one tablet. (ex. 11)
			SCREENCONFIG[$j]=$NAME
		done
	fi
done

declare -p SCREENCONFIG > $HOME/.config/wacomtodisplays.sh
kdialog --msgbox "Wacom Config saved"