#!/bin/bash

function mapwacomdevice(){

WACOM="$2"
OUTPUT="$1"

xsetwacom --set "$WACOM" ResetArea

AREALEFT=$(xsetwacom --get "$WACOM" Area | awk '{print $1}')
AREATOP=$(xsetwacom --get "$WACOM" Area | awk '{print $2}')
AREARIGHT=$(xsetwacom --get "$WACOM" Area | awk '{print $3}')
AREABOTTOM=$(xsetwacom --get "$WACOM" Area | awk '{print $4}')

AREAWIDTH=$(echo $AREARIGHT-$AREALEFT | bc -l)
AREAHEIGHT=$(echo $AREABOTTOM-$AREATOP | bc -l)

echo $AREAWIDTH
echo $AREAHEIGHT

round(){
    echo $(printf %.$2f $(echo "scale=$2;(((10^$2)*$1)+0.5)/(10^$2)" | bc))
};

SCREEN=$(xrandr -q | grep $OUTPUT | grep -oP '[0-9]+x[0-9]+')

SCREENWIDTH=$(echo $SCREEN | sed 's/x.*$//')
SCREENHEIGHT=$(echo $SCREEN | sed 's/^.*x//')

echo "screen width: $SCREENWIDTH"
echo "screen height: $SCREENHEIGHT"

# if rotation is cw or ccw, then swap screenwidth and screenheight
if [[ "$(xsetwacom --get $WACOM Rotate)" == "cw" || "$(xsetwacom --get $WACOM Rotate)" == "ccw" ]]
then
	echo "swapping"
	temp=$SCREENWIDTH
	SCREENWIDTH=$SCREENHEIGHT
	SCREENHEIGHT=$temp
fi

echo $SCREENWIDTH $SCREENHEIGHT

RESULTWIDTH=$(echo $AREAHEIGHT/$SCREENHEIGHT*$SCREENWIDTH | bc -l)
RESULTHEIGHT=$(echo $AREAWIDTH/$SCREENWIDTH*$SCREENHEIGHT | bc -l)

if (( $(echo $RESULTWIDTH \> $AREAWIDTH | bc -l) )); then
	RESULTHEIGHT=$(echo $AREAWIDTH/$RESULTWIDTH*$AREAHEIGHT | bc -l)
	RESULTWIDTH=$AREAWIDTH
else
	RESULTWIDTH=$(echo $AREAHEIGHT/$RESULTHEIGHT*$AREAWIDTH | bc -l)
	RESULTHEIGHT=$AREAHEIGHT
fi

echo $RESULTWIDTH
echo $RESULTHEIGHT

RESULTLEFT=$(round $(echo "($AREAWIDTH-$RESULTWIDTH)/2" | bc) 0)
RESULTTOP=$(round $(echo "($AREAHEIGHT-$RESULTHEIGHT)/2" | bc) 0)
RESULTRIGHT=$(round $(echo "($AREALEFT+$RESULTWIDTH)+$RESULTLEFT" | bc) 0)
RESULTBOTTOM=$(round $(echo "($AREATOP+$RESULTHEIGHT)+$RESULTTOP" | bc) 0)

echo $RESULTLEFT $RESULTTOP $RESULTRIGHT $RESULTBOTTOM

xsetwacom set "$WACOM" MapToOutput $OUTPUT
xsetwacom set "$WACOM" Area $RESULTLEFT $RESULTTOP $RESULTRIGHT $RESULTBOTTOM
};

source $HOME/.config/wacomtodisplays.sh
[ $? -eq 0 ] || create-mapwacom-config.sh
source $HOME/.config/wacomtodisplays.sh

#if [[ -f "$HOME/.config/wacomtodisplays.sh" ]]
#then
#	source $HOME/.config/wacomtodisplays.sh
#else
#	create-config.sh
#fi
#
#if [[ -z SCREENCONFIG ]]
#then
#	create-config.sh
#fi

# now iterate through the xwacom devices.
# If we find them in our SCREENCONFIG, then we will run mapwacomdevice together with the screen specified in SCREENCONFIG
for j in $(xsetwacom --list | sed 's/^.*id: //' | sed 's/	.*$//')
do
	[ ${SCREENCONFIG[$j]} ] && mapwacomdevice ${SCREENCONFIG[$j]} $j
done


#set -x
#xrandr | grep connected | grep -v disconnected | while read -r i
#do
#	NAME=$(echo $i | sed 's/ .*//')
#	FORMAT=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+')
#	WIDTH=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 1p)
#	HEIGHT=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 2p)
#	XPOS=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 3p)
#	YPOS=$(echo $i | grep -oP '[0-9]+x[0-9]+\+[0-9]+\+[0-9]+' | grep -oP '[0-9]+' | sed -n 4p)
#	let "MYXPOS = ($WIDTH+1)/2 + $XPOS"
#	let "MYYPOS = ($HEIGHT+1)/2 + $YPOS"
#	SCREEN=$(
#		(sleep .4;wmctrl -r "MapStylus Screen Finder" -R "MapStylus Screen Finder" -e 0,$MYXPOS,$MYYPOS,-1,-1) |
#			kdialog --yes-label Laptop --no-label Wacom --cancel-label other --title "MapStylus Screen Finder" --yesnocancel "What screen is this dialog on?";
#		echo $?
#	)
#
#	if [ $SCREEN -eq 0 ]
#	then
#		for j in $(xsetwacom --list | grep -v One | sed 's/^.*id: //' | sed 's/	.*$//')
#		do
#			mapwacomdevice $NAME $j
#		done
#	elif [ $SCREEN -eq 1 ]
#	then
#		for j in $(xsetwacom --list | grep One | sed 's/^.*id: //' | sed 's/	.*$//')
#		do
#			mapwacomdevice $NAME $j
#		done
#	fi
#done
